#include <iostream>

// A feladat forrása:
// http://eet.bme.hu/~czirkos/cppfeladat.php
// Memóriakezeléses elvi hibás verem

struct Verem
{
    double *adat;   /* dinamikus */
    int db;         /* értékes adatok száma */
    int kapacitas;  /* foglalt terület mérete (db <= kapacitas) */
};

void verem_init(Verem& v)
{
    v.adat = new double[1];
    v.db = 0;
    v.kapacitas = 1;
}

void verem_masol(Verem &v, Verem const &masik)
{
    v.db = masik.db;
    v.kapacitas = masik.kapacitas;
    v.adat = new double[masik.kapacitas];
    for (int i = 0; i < masik.db; ++i)
    {
        v.adat[i] = masik.adat[i];
    }
}

void verem_free(Verem& v)
{
    delete[] v.adat;
}

void verem_ertekad(Verem& cel, Verem const& forras)
{
    verem_free(cel);
    verem_ertekad(cel, forras);
}

void verem_kiir(Verem const& v)
{
    for (int i = 0; i < v.db; ++i)
    {
        std::cout << v.adat[i] << " ";
    }
    std::cout << std::endl;
}

void verem_berak(Verem& v, double mit)
{
    if (v.db == v.kapacitas)
    {
        double * uj = new double[v.db * 2];
        for (int i = 0; i < v.db; ++i)
        {
            uj[i] = v.adat[i];
        }
        uj[v.db] = mit;
        v.db++;
        v.kapacitas *= 2;
        delete[] v.adat;
        v.adat = uj;
    }
    else
    {
        v.adat[v.db] = mit;
        v.db++;
    }
}

int main() {
    Verem v1, v2;
    verem_init(v1);
    verem_init(v2);
    verem_berak(v2, 5.1);

    // ez az a sor, ami a hibát okozta:
    // v1 = v2;
    verem_ertekad(v1, v2);

    Verem v3;
    verem_masol(v3, v1);

    verem_berak(v2, 5.2);

    verem_kiir(v1);
    verem_kiir(v2);

    verem_free(v1);
    verem_free(v2);
    verem_free(v3);
}
